<template>
  <div>
    <ObSelect
            v-model="selectedRole"
            label="Для какой роли"
            placeholder="Выберите роль"
            :items="currentRoles"
            :is-standart="true"
            value-exp="code"
            v-if="isParticipant"
            class="mb20"
    />
    <template v-if="isManualInput(selectedRole)">
      <div class="risk-group-input">
        <div
                class="risk-group-input__item form-group"
                v-for="(item, index) in currentRisks"
                :key="index"
        >
          <ObSelect
                  class="risk-group-input__item-group"
                  v-model="item.uuid"
                  label="Группа риска"
                  placeholder="Выберите группу"
                  :items="getCurrentRiskGroupsList(item.uuid)"
                  :value-exp="riskGroupSelectorValueKey"
                  display-exp="title"
                  :is-standart="true"
                  @input="setColor(item)"
                  :disabled="formData.datatype === 'BOOLEAN'"
          />
          <template v-if="formData.datatype === 'NUMERIC'">
            <ObInput
                    class="risk-group-input__item-value"
                    label="Мин"
                    v-model="item.constraints.from"
                    placeholder="Введите значение"
            />
            <ObInput
                    class="risk-group-input__item-value"
                    label="Макс"
                    v-model="item.constraints.to"
                    placeholder="Введите значение"
            />
          </template>
          <template v-else-if="formData.datatype === 'DATE'">
            <ObInput
                    class="risk-group-input__item-value"
                    label="Минимум, мес."
                    v-model="item.constraints.from"
                    placeholder="Введите значение"
            />
            <ObInput
                    class="risk-group-input__item-value"
                    label="Максимум, мес."
                    v-model="item.constraints.to"
                    placeholder="Введите значение"
            />
          </template>
          <template v-else-if="formData.datatype === 'DATETIME'">
            <ObInput
                    class="risk-group-input__item-value"
                    label="Минимум, мес."
                    v-model="item.constraints.from"
                    placeholder="Введите значение"
            />
            <ObInput
                    class="risk-group-input__item-value"
                    label="Максимум, мес."
                    v-model="item.constraints.to"
                    placeholder="Введите значение"
            />
          </template>
          <template v-else-if="formData.datatype === 'BOOLEAN'">
            <ObSelect
                    class="risk-group-input__item-group"
                    :label="formData.title"
                    :placeholder="'Выберите'"
                    :items="booleanRisksSelector"
                    v-model="item.constraints.value"
                    @input="setBooleanValues (item, $event)"
            />
          </template>
          <template v-else-if="formData.datatype === 'CHECKLIST' && adminSource.dictionary_code">
            <ObSelect
                    class="risk-group-input__item-group"
                    :label="formData.title"
                    :placeholder="'Выберите'"
                    :remote-opt="{
                          method: api.dictionary.dictionaryDropdownByType,
                          arguments: {
                            code: adminSource.dictionary_code
                          },
                          loadEvent: isNew && 'open'
                        }"
                    :remote-trigger="adminSource.dictionary_code"
                    :is-multiselect="true"
                    :is-standart="true"
                    :is-dropdown="true"
                    v-model="item.constraints.value"
            />
          </template>
          <button
                  class="risk-group-input__item-remove"
                  @click="removeRiskGroup(index)"
                  v-if="isShowRemoveGroupButton"
          >
            <i class="icon close"/>
          </button>
        </div>
        <button
                class="risk-group-input__add"
                @click="addRiskGroup"
                v-if="isAddRiskGroupButton"
        >
          Добавить группу риска
        </button>
        <RiskGraph :items="currentRisks" :field-name="formData.title" v-if="isShowGraph"/>
      </div>
    </template>
    <template v-else>
      <div style="display: flex; justify-content: center;">
        <div style="width: 572px; font-size: 24px; line-height: 30px; text-align: center; letter-spacing: 0.2px; color: #757884;">
          Настройте свои параметры для групп риска<br>или используйте значения по умолчанию
        </div>
      </div>
      <div style="display: flex; justify-content: center;">
        <div style="width: 402px; font-size: 12px; line-height: 16px; text-align: center; letter-spacing: 0.4px;">
          Значения по умолчанию рассчитаны по данным нашей аналитической системы и подходят для большинства
          пользователей.
          Вы можете откорректировать их под особенности вашей работы, или в любой момент можете вернуться к ним, нажав
          кнопку в левом нижнем углу.
        </div>
      </div>
      <div style="display: flex; justify-content: center;">
        <ObButton
                class="w270"
                label="Взять значения по умолчанию"
                type="outline"
                @click="setDefaultRisks"
        />
      </div>
      <div style="display: flex; justify-content: center;">
        <ObButton
                class="w270"
                label="Настроить самостоятельно"
                type="flat"
                @click="goSetRisks"
        />
      </div>
    </template>
  </div>
</template>

<script>
  import ObSelect from 'common-components/src/obComponents/obSelect'
  import ObInput from 'common-components/src/obComponents/obInput'
  import ObButton from 'common-components/src/obComponents/obButton'
  import RiskGraph from './RiskGraph'
  import riskIconMixin from '@/mixins/risk-icon'
  import api from '@/api'

  export default {
    name: 'CardConfiguratorFieldRisks',
    components: {
      ObSelect,
      ObButton,
      RiskGraph,
      ObInput
    },
    mixins: [ riskIconMixin ],
    props: {
      dataSource: {
        type: Object,
        default: () => {}
      },
      formData: {
        type: Object,
        default: () => {}
      },
      activities: {
        type: Array,
        default: () => []
      },
      type: {
        type: String,
        default: 'participant'
      }
    },
    data () {
      return {
        rolesList: [],
        riskGroups: [],
        risks: {},
        selectedRole: null,
        booleanRisksSelector: [
          {
            uuid: true,
            title: 'Да'
          },
          {
            uuid: false,
            title: 'Нет'
          }
        ],
        api
      }
    },
    async mounted () {
      try {
        if (this.isParticipant) {
          let roles = await api.cardField.getRoles()
          this.rolesList = roles && roles.content || []
        }

        this.riskGroups = await api.card.getRiskGroups()
        this.riskGroups = this.riskGroups.map(({icon, ...keepAttrs}) => {
          icon; // Nice no unused vars in linter
          return {...keepAttrs, icon: this.getRiskClass(keepAttrs.color)}
        })
        this.generateRisksObj()
      } catch (e) {
        console.error(e);
        this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
      }
    },
    computed: {
      isNew () {
        return !this.formData.uuid
      },
      adminSource () {
        return this.dataSource && this.dataSource.AdminDataSourceSettings || {}
      },
      isParticipant () {
        return this.type === 'participant'
      },
      isResource () {
        return this.type === 'resource'
      },
      currentRolesCodes () {
        return this.formData && this.formData && this.formData.participant_role_codes || []
      },
      riskGroupSelectorValueKey () {
        return this.getUuidGroupKeyByRole(this.selectedRole)
      },
      currentRisks () {
        return this.isParticipant ? this.risks[this.selectedRole] || [] : this.risks || []
      },
      currentRoles () {
        let result = []

        if (this.currentRolesCodes) {
          this.currentRolesCodes.forEach((code) => {
            let roleInfo = this.rolesList.find(item => item.code === code)
            if (code === 'CARRIER') {
              this.formData.activities.forEach(activity => {
                let activityInfo = this.activities.find(item => item.uuid === activity)
                let computedCode = `${code}_${activity}`
                if (roleInfo && activityInfo) {
                  let computedTitle = `${roleInfo.title}. ${activityInfo.denomination}`
                  result.push({ ...roleInfo, code: computedCode, title: computedTitle })
                }
              })
            } else {
              result.push({ ...roleInfo })
            }
          })
        }

        return result
      },
      addedRiskGroupsUuids () {
        if (!this.currentRisks || !this.currentRisks.length) return null
        return this.currentRisks.map(item => item.uuid)
      },
      isAddRiskGroupButton () {
        if (!this.currentRisks || !this.currentRisks.length) return true

        if (['NUMERIC', 'CHECKLIST', 'DATE', 'DATETIME'].includes(this.formData.datatype)) {
          return this.currentRisks.length < 6
        }

        if (this.formData.datatype === 'BOOLEAN') {
          return this.currentRisks.length < 2
        }

        return false
      },
      isShowGraph () {
        return ['NUMERIC', 'DATE', 'DATETIME'].includes(this.formData.datatype) && this.currentRisks.length
      },
      isShowRemoveGroupButton () {
        return this.currentRisks && this.currentRisks.length > 2
      }
    },
    watch: {
      'formData.participant_role_codes' () {
        if (this.isParticipant) {
          this.generateRisksObj()
        }
      },
      'formData.activities' () {
        if (this.isParticipant) {
          this.generateRisksObj()
        }
      },
      'dataSource.riskValues' () {
        this.generateRisksObj()
      }
    },
    methods: {
      addRiskGroup () {
        if (this.currentRisks.length < this.riskGroups.length) {
          if (this.isParticipant) {
            this.risks[this.selectedRole].push({ ...this.riskGroupInitData() })
          } else {
            this.risks.push({ ...this.riskGroupInitData() })
          }
        }
      },
      removeRiskGroup (index) {
        if (this.isParticipant) {
          this.risks[this.selectedRole] = this.risks[this.selectedRole].filter((item, i) => i !== index)
        } else {
          this.risks = this.risks.filter((item, i) => i !== index)
        }
      },
      riskGroupInitData () {
        let datatype = this.formData.datatype

        const typeMap = {
          boolean: 'boolean',
          numeric: 'numeric',
          checklist: 'ref_list',
          date: 'numeric',
          datetime: 'numeric'
        }

        let constraints = {
          "@type": typeMap[datatype.toLowerCase()],
        }

        if (['NUMERIC', 'DATE', 'DATETIME'].includes(datatype)) {
          constraints.from = null
          constraints.to = null
        } else if (datatype === 'BOOLEAN') {
          constraints.value = null
        } else if (datatype === 'CHECKLIST') {
          constraints.value = []
        }

        return {
          loss_group_uuid: null,
          risk_color: null,
          color: null,
          constraints,
          is_active: true
        }
      },
      getCurrentRiskGroupsList (uuid) {
        if (!this.addedRiskGroupsUuids) return []
        return this.riskGroups.filter(item => {
          return !this.addedRiskGroupsUuids.includes(item[this.riskGroupSelectorValueKey]) || item[this.riskGroupSelectorValueKey] === uuid
        })
      },
      setDefaultRisks () {
        this.$emit('on-set-default-risks')
      },
      setColor (item) {
        let uuid = item.uuid
        let group = this.riskGroups.find(item => item[this.riskGroupSelectorValueKey] === uuid)

        item.risk_color = group.color
        item.color = group.color
      },
      goSetRisks () {
        if (this.isParticipant) {
          this.risks[this.selectedRole] = []
        } else {
          this.risks = []
        }
      },
      generateRisksObj ({ defaultRole = null } = {}) {
        let fieldRisks = this.dataSource.riskValues

        if (this.isParticipant) {
          let selectedRole = null

          if (this.currentRoles && this.currentRoles.length) {
            this.currentRoles.forEach((role, index) => {
              let codeArr = role.code.split('_')
              let role_code = codeArr[0]
              if (!index) {
                selectedRole = role_code
              }
              if (role_code === 'CARRIER') {
                this.formData.activities.forEach((activity, actIndex) => {
                  let code = `${role_code}_${activity}`
                  if (!actIndex) {
                    selectedRole = code
                  }

                  this.$set(this.risks, code,  null)
                })
              } else {
                this.$set(this.risks, role_code,  null)
              }
            })
          }

          if (fieldRisks.length) {
            for (let key in this.risks) {
              let codeArr = key.split('_')
              let role_code = codeArr[0]
              let activity_uuid = codeArr[1]

              let result = fieldRisks.filter(item => {
                let roleCodeLocal = typeof item.role === 'string' ? item.role : item.role.code
                return roleCodeLocal.toLowerCase() === role_code.toLowerCase() && (!activity_uuid || !item.activity || (activity_uuid === item.activity.uuid))
              }).map(item => {
                return { ...item, uuid: item.uuid || item.loss_group_uuid }
              })
              this.risks[key] = result.length ? result : null
            }
          }

          this.$nextTick(() => {
            this.selectedRole = defaultRole || selectedRole
          })
        }

        if (this.isResource) {
          this.risks = fieldRisks.map(item => {

            item.uuid = item.uuid || item.loss_group_uuid
            return item
          })
        }
      },
      isManualInput (role) {
        return Boolean(this.risks[role]) || this.isResource
      },
      setBooleanValues (item, value) {
        let siblingsItem = this.currentRisks.find(risk => risk.uuid !== item.uuid)
        if (siblingsItem && siblingsItem.constraints) {
          siblingsItem.constraints.value = !value
        }
      },
      getUuidGroupKeyByRole (role) {
        if (role) {
          role = role.split('_')[0]

          if (role === 'CLIENT') {
            return 'participant_payment_risk_group_uuid'
          } else if (role === 'CARRIER') {
            return 'cargo_loss_risk_group_uuid'
          }
        }

        return 'uuid'
      }
    }
  }
</script>

<style lang="scss" scoped>
  .w270 {
    width: 270px;
  }

  .risk-group-input__item-group {
    &::v-deep {
      .ob-selector__value {
        display: flex;
        align-items: center;
      }

      .ob-selector__value-html {
        display: flex;
      }
    }
  }
</style>

<style lang="scss">
  .risk-group-input {
    &__item {
      display: flex;
      justify-content: space-between;
      align-items: center;
      & > .ob-selector {
        margin-bottom: 22px;
      }
      &-group {
        width: 50%;
        margin-right: 20px;
      }
      &-value {
        width: 25%;
        margin-right: 20px;
      }
      &-remove {
        outline: none;
        cursor: pointer;
        border: none;
        background-color: transparent;
        color: $color-grey-border;
        i {
          display: flex;
          align-items: center;
          justify-content: center;
        }
      }
    }
  }
</style>
